package lib.ui.reactive;

import util.Pos;
import util.Rect;
import util.Vec.Vec2;

using tink.CoreApi;

abstract class UIElement {
	/**
		Render the element inside the bounds. `offset` is the offset to the parents position
		and can be used to calculate the absolute position of element.
		Just save `offset` and pass it to the children.
	**/
	abstract public function render(bounds:Vec2<Int>, offset: Pos):Canvas;
	public var changed(default, null):Signal<Noise>;
	private final changedTrigger:SignalTrigger<Noise> = Signal.trigger();
	public final eventListner:UIEvents = {};

	public function new(events: UIEvents = null) {
		changed = changedTrigger.asSignal();
		if (events != null){
			this.eventListner = events;
		}
	}

	public static function getElementInMap(pos: Pos,elementMap: Map<Rect,UIElement>):Null<UIElement>{
		for (k => v in elementMap){
			if (k.isInside(pos)){
				return v;
			}
		}

		return null;
	};
}
